import numpy as np
import matplotlib.pyplot as plt
from utils import Color, getColorChannel

IMAGE_INDEX = 3294
Y_RANGE = 5
X_RANGE = 25
ORIGINAL_INTERESTING_POSITION = [5752, 1695][::-1]
INTERESTING_POSITION = np.array(ORIGINAL_INTERESTING_POSITION) // 2
COLOR = Color.RED

def getImageFilePath(imageIndex):
    return f'../rafael/240424/photos/DSC0{imageIndex}.ARW'

def getImageColorChannel(imageIndex, color):
    imageFilePath = getImageFilePath(imageIndex)
    return getColorChannel(imageFilePath, color).astype(np.int32)

firstColorChannel = getImageColorChannel(IMAGE_INDEX, COLOR)
secondColorChannel = getImageColorChannel(IMAGE_INDEX + 1, COLOR)
differenceColorChannel = firstColorChannel - secondColorChannel
print(differenceColorChannel.shape)

def crop(image, interestingPosition, yRange, xRange):
    return image[interestingPosition[0] - yRange: interestingPosition[0] + yRange, interestingPosition[1] - xRange: interestingPosition[1] + xRange]

#colorChannel = crop(multipleColorsImage, ORIGINAL_INTERESTING_POSITION, Y_RANGE, X_RANGE)
colorChannelToDisplay = differenceColorChannel
colorChannelToDisplay = crop(colorChannelToDisplay, INTERESTING_POSITION, Y_RANGE, X_RANGE)
print(colorChannelToDisplay.shape)
plt.imshow(colorChannelToDisplay)
plt.show()